<template>
  <view-list
    v-on:model-reload="loadList"
    v-on:export-csv="downloadCsv"
    v-on:model-search="search($event.query, $event.field)"
    :status="status"
    title="Lokalizacje"
    :button="true"
    button_link="/lokalizacje/nowa"
    button_title="Dodaj nową lokalizację"
    :length="filteredData.length"
  >
    <RecycleScroller :items="filteredData" :item-size="106" v-if="renderHack">
      <template v-slot="{ item }">
        <location-list-item v-bind="item" />
      </template>
    </RecycleScroller>
  </view-list>
</template>

<script lang="ts">
import { Options } from "vue-class-component";

import ViewList from "@/views/list-views/ViewList.vue";
import LocationListItem from "@/components/list/custom/LocationListItem.vue";

import { CsvDownload, LocationData, UserData } from "@/interfaces";
import RecordList from "@/views/list-views/RecordList";
import { NApi } from "@/interfaces/connector";
import Fuse from "fuse.js";

@Options({
  components: {
    ViewList,
    LocationListItem,
  },
})
export default class Locations extends RecordList<LocationData> {
  public API_CALL = NApi.getLocations;

  async downloadCsv() {
    await new CsvDownload(" ; ").download(this.filteredData);
  }

  async onLoaded(data: LocationData[]) {
    const options = {
      includeScore: false,
      keys: ["name", "street", "post_code", "city"],
    };

    this.rawData = data;
    this.fuseData = Object.freeze(new Fuse(data, options));
    this.filter();
  }
}
</script>
